#include "scripts.h"
#include <stdarg.h>
#ifdef WIN32
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#endif
#include "engine.h"
#include "gmmain.h"
#include "damagehook.h"



Hook *ServerDamage = new Hook;

bool __stdcall Proc_ServerDamage(DamageableGameObj *Object, OffenseObjectClass *Offense, float DamageMultipler, int Warhead)
{	
	if(!Offense || !Offense->Damager.Reference || !Offense->Damager.Reference->obj)
	{
		return true;
	}

	if (Offense->damage < 0)
	{
		return true;
	}

	if (Object->Defense.Health.Get() == 0.0f)
	{
		return true;
	}
	
	GameObject *Damager = (GameObject *)Offense->Damager.Reference->obj;
	GameObject *Victim = (GameObject *)Object->Defense.Owner.Reference->obj;

	if (Damager && Is_Vehicle(Damager))
	{			
		if (Get_Vehicle_Mode(Damager) == TURRET)//tested, sees ob/agt as vehicles
		{
			return true;
		}
		else if ((strstr(Commands->Get_Preset_Name(Damager),"CnC_GDI_Harvester")) || (strstr(Commands->Get_Preset_Name(Damager),"CnC_Nod_Harvester")))//tested
		{
			return true;
		}
		else if (Get_Vehicle_Mode(Damager) != TURRET)  // stops neutral shell damage - tested
		{
			return false;
		}
		return true;
	}
	//Offense->damage = 9999.0f; //lolol
	return true;
}
		
__declspec(naked) void Hook_ServerDamage()
{
	_asm {
		push ebp
		mov ebp, esp
		push ecx
		push [ebp+0x10]
		push [ebp+0xC]
		push [ebp+8]
		push ecx
		call Proc_ServerDamage
		test al, al
		pop ecx
		mov esp, ebp
		pop ebp
		jz no_damage
		sub esp, 8
		push ebx
		push ebp
		push esi
		mov ebx, 0x6D8DC6
		jmp ebx
no_damage:
		retn 0xC
	}
}


void Hooking::Install()
{
	ServerDamage->Install('\xE9', 0x6D8DC0, (int)&Hook_ServerDamage, "");
}

void Hooking::Uninstall()
{
	ServerDamage->Uninstall();
}

bool WriteMemory(int Address, const void* Buffer, int Size) {
	
	bool ret = 1;
	DWORD OldProtect;
	HANDLE Process = OpenProcess(PROCESS_ALL_ACCESS, false, GetCurrentProcessId());
	VirtualProtectEx(Process, (LPVOID)Address, Size, PAGE_EXECUTE_READWRITE, &OldProtect);
	if (!WriteProcessMemory(Process, (LPVOID)Address, Buffer, Size, NULL)) {
		ret = 0;
	}
	VirtualProtectEx(Process, (LPVOID)Address, Size, OldProtect, NULL);
	CloseHandle(Process);
	return ret;
}

bool ReadMemory(int Address, void* Buffer, int Size)
{
	bool ret = 1;
	DWORD OldProtect;
	HANDLE Process = OpenProcess(PROCESS_ALL_ACCESS, false, GetCurrentProcessId());
	VirtualProtectEx(Process, (LPVOID)Address, Size, PAGE_EXECUTE_READWRITE, &OldProtect);
	if (!ReadProcessMemory(Process, (LPVOID)Address, Buffer, Size, NULL))
	{
		ret = 0;
	}
	VirtualProtectEx(Process, (LPVOID)Address, Size, OldProtect, NULL);
	CloseHandle(Process);
	return ret;
}

//This is the stuff that OnOes does with this damage hook, might be useful for your own stuff:
/*bool __stdcall Proc_ServerDamage(DamageableGameObj *Object, OffenseObjectClass *Offense, float DamageMultipler, int Warhead)
{	
	if(!Offense || !Offense->Damager.Reference || !Offense->Damager.Reference->obj)
	{
		return true;
	}

	if (Offense->damage < 0)
	{
		return true;
	}

	if (Object->Defense.Health.Get() == 0.0f)
	{
		return true;
	}
	
	GameObject *Damager = (GameObject *)Offense->Damager.Reference->obj;
	GameObject *Victim = (GameObject *)Object->Defense.Owner.Reference->obj;

	if(Damager && Victim && Commands->Is_A_Star(Damager))
	{
	// make the distance for orca the same as the apache
		if(Get_Vehicle(Damager))
		{
			if(!Is_Building(Victim))
			{
				if ((strstr(Commands->Get_Preset_Name(Get_Vehicle(Damager)),"CnC_GDI_Orca")) || (strstr(Commands->Get_Preset_Name(Get_Vehicle(Damager)),"CnC_Nod_Apache")))
				{
					float Distance = Commands->Get_Distance(Commands->Get_Position(Damager),Commands->Get_Position(Victim));
		
					if(Distance > 80) 
					{
						return false;
					}
				}
			}
		}
		
		//change the damage done to flying vehicles from ramjets
		//const char *weapon = Get_Current_Weapon(Damager); if(!weapon) return 0;

		//if (!strcmp("CnC_Weapon_RamjetRifle_Player", weapon))
		//{ 
		//	if(!Get_Vehicle(Damager) && Settings::RamJetDamage)
		//	{
		//		if(Is_Vehicle(Victim))
		//		{
		//			if(Get_Vehicle_Mode(Victim) == FLYING)
		//			{
		//				Offense->damage = 120.0f;
		//				return true;
		//			}
		//		}
		//	}
		//}
	}

	//check defences and vehicles
	if (Damager && Is_Vehicle(Damager))
	{
		if (Get_Vehicle_Mode(Damager) == TURRET)//tested, sees ob/agt as vehicles
		{
			return true;
		}
		else if ((strstr(Commands->Get_Preset_Name(Damager),"CnC_GDI_Harvester")) || (strstr(Commands->Get_Preset_Name(Damager),"CnC_Nod_Harvester")))//tested
		{
			return true;
		}
		else if (Get_Vehicle_Mode(Damager) != TURRET)  // stops neutral shell damage - tested
		{
			return false;
		}
	}
	
	if(Damager && Victim)
	{
		if(Is_Building(Victim) && Commands->Is_A_Star(Damager))
		{
			// block building damage on hour glass on the hill - tested
			if ((stricmp(The_Game()->MapName,"C&C_Hourglass.mix") == 0) && Settings::HillCamping)
			{
				if(Get_Vehicle(Damager))
				{
					if ((strstr(Commands->Get_Preset_Name(Get_Vehicle(Damager)),"CnC_GDI_MRLS")) || (strstr(Commands->Get_Preset_Name(Get_Vehicle(Damager)),"CnC_Nod_Mobile_Artillery")))
					{
						Vector3 Pos = Commands->Get_Position(Damager);
						if(Pos.Z > 20)
						{
							return false;
						}
					}
				}		
			}

			//if(Commands->Get_Health(Victim) == 1) //&& Settings::EnableRevive)
			//{
			//	if(!Is_Script_Attached(Victim,"ReviveBuildings"))
			//	{
			//		Attach_Script_Once(Victim, "ReviveBuildings", "");
			//	}
			//	printf("building destroyed\n");
			//	return false;
			//}
		}	
		//!protect stuff - tested
		if(Damager && Victim)
		{
			if(Commands->Is_A_Star(Damager) && Commands->Is_A_Star(Victim))
			{
				Player *p = PlayerClass::FindbyId(Get_Player_ID(Damager));
				if(!p)
				{
					return false;
				}

				if(p->Protected)
				{
					return false;
				}

				Player *x = PlayerClass::FindbyId(Get_Player_ID(Victim));
				if(!x)
				{
					return false;
				}

				if(x->Protected)
				{
					return false;
				}
			}
		}
	}
	return true;
}
	*/